﻿using GridExample.Model;
using Syncfusion.SfDataGrid.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace GridExample.ViewModel
{
    public class ViewModel : INotifyPropertyChanged
    {
        OrderInfoRepository order;
        public ViewModel()
        {
            selectionCommand = new Command<SfDataGrid>(onSelectionChanged);
            selectedItems = new ObservableCollection<object>();
            order = new OrderInfoRepository();
            SetRowstoGenerate(100);
        }

        #region ItemsSource

        private ObservableCollection<OrderInfo> ordersInfo;

        public ObservableCollection<OrderInfo> OrdersInfo
        {
            get { return ordersInfo; }
            set { this.ordersInfo = value; RaisePropertyChanged("OrdersInfo"); }
        }

        #endregion

        #region Commands

        private Command<SfDataGrid> selectionCommand;
        public Command<SfDataGrid> SelectionCommand
        {
            get { return selectionCommand; }
            set { selectionCommand = value; }
        }

        #endregion

        #region Selection

        private ObservableCollection<object> selectedItems;

        public ObservableCollection<object> SelectedItems
        {
            get
            {
                return selectedItems;
            }
            set
            {
                selectedItems = value;
            }
        }

        #endregion


        #region ItemSource Generator

        public void SetRowstoGenerate(int count)
        {
            ordersInfo = order.GetOrderDetails(count);
        }

        #endregion

        #region INotifyPropertyChanged implementation

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion

        private void onSelectionChanged(SfDataGrid obj)
        {
            selectedItems = obj.SelectedItems;
        }

    }
}
